"""
* Author: "PepDebian(peppermintosteam@proton.me)
*
* License: SPDX-License-Identifier: GPL-3.0-or-later
*
* This file is used to keep functions that are used for the Welcome
* Screen
"""
import os.path
import platform

# This will get the logged in user
gusr = os.getlogin()
spath = "/home/" + gusr + "/.local/share/pmostools/peptools"

def set_browser():
    """
    Determine the system  and set the browser type
    """
    architecture = platform.architecture()[0]
    if '64bit' in architecture:
        browser_type = "min"
    else:
        browser_type = "luakit"
    return browser_type


def suggested_packages():
    """ Open the suggested packages """
    os.system('python3 ' + spath + '/suggested.py')


def about():
    """Open the about page"""
    os.system('min --new-window https://peppermintos.com/about/ &'
              )


##SSB's###
def pep_docs():
    """Open Pep Docs"""
    browser_type = set_browser()
    url = "https://peppermint_os.codeberg.page/html/"
    command = (
        f'{browser_type} --new-window {url} &'
    )
    os.system(command)

# Community Section
def mastodon():
    """Open Mastodon"""
    browser_type = set_browser()
    url ="https://fosstodon.org/@peppermintos"
    command = (
        f'{browser_type} --new-window {url} &'
        )
    os.system(command)


def code_berg():
    """Open Codeberg"""
    browser_type = set_browser()
    url ="https://codeberg.org/Peppermint_OS"
    command = (
        f'{browser_type} --new-window {url} &'
        )
    os.system(command)


def matrix():
    """Open Matrix"""
    browser_type = set_browser()
    url ="https://matrix.to/#/!JhPtEbNexzFaoOkvGp:matrix.org?via=matrix.org"
    command = (
        f'{browser_type} --new-window {url} &'
        )
    os.system(command)


def source_forge():
    """Open Sourceforge"""
    browser_type = set_browser()
    url ="https://sourceforge.net/p/peppermintos/pepos/"
    command = (
        f'{browser_type} --new-window {url} &'
        )
    os.system(command)


def build_date():
    """Open BuildDate wiki"""
    browser_type = set_browser()
    url ="https://sourceforge.net/p/peppermintos/pepwiki/BuildDate/"
    command = (
        f'{browser_type} --new-window {url} &'
        )
    os.system(command)
